import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flyyfluttersdk/Flyy.dart';

class ReusableAppbarWidget {
  static getAppBar(BuildContext context, String title) {
    return AppBar(
      bottomOpacity: 0.0,
      elevation: 0.0,
      titleSpacing: 0.0,
      leading: IconButton(
        icon: Icon(Icons.arrow_back, color: Colors.white),
        onPressed: () {
          if (Navigator.canPop(context)) {
            Navigator.of(context, rootNavigator: false).pop();
          } else {
            SystemNavigator.pop();
          }
        },
      ),
      title: Text(
        title,
        style: TextStyle(fontSize: 18),
      ),
      backgroundColor: Flyy.TOOLBAR_COLOR,
    );
  }
}
