import 'package:flyyfluttersdk/model/FlyyTournamentData.dart';

class FlyyTournamentHistory {
  bool success;
  String partner;
  String shareText;
  int totalUserPoints;
  List<FlyyTournamentData> live;
  List<FlyyTournamentData> completed;

  FlyyTournamentHistory(
      {this.success,
      this.partner,
      this.shareText,
      this.totalUserPoints,
      this.live,
      this.completed});

  factory FlyyTournamentHistory.fromJson(Map<String, dynamic> json) {
    return FlyyTournamentHistory(
      success: json["success"],
      partner: json["partner"],
      shareText: json["share_text"],
      totalUserPoints: json["total_user_points"],
      live: json.containsKey('live') && json['live'] != null
          ? List<FlyyTournamentData>.from(
              json['live'].map((data) => FlyyTournamentData.fromJson(data)))
          : null,
      completed: json.containsKey('completed') && json['completed'] != null
          ? List<FlyyTournamentData>.from(json['completed']
              .map((data) => FlyyTournamentData.fromJson(data)))
          : null,
    );
  }
}
