import 'package:flyyfluttersdk/model/FlyyAccountDetails.dart';
import 'package:flyyfluttersdk/model/FlyyTransactions.dart';
import 'package:flyyfluttersdk/model/FlyyTransferRequest.dart';

class FlyyWalletCompleteData {
  int balance;
  int totalEarned;
  int totalRedeemed;
  String rewardType;
  String rewardIcon;
  String walletMessage;
  List<FlyyTransactions> flyyTransactions;
  bool isRedeemable;
  int minRedeemAmount;
  int transactionsCount;
  FlyyTransferRequest flyyTransferRequest;
  FlyyAccountDetails flyyAccountDetails;

  FlyyWalletCompleteData(
      {this.balance,
      this.totalEarned,
      this.totalRedeemed,
      this.rewardType,
      this.rewardIcon,
      this.walletMessage,
      this.flyyTransactions,
      this.isRedeemable,
      this.minRedeemAmount,
      this.transactionsCount,
      this.flyyTransferRequest,
      this.flyyAccountDetails,
      isAvailableNow});

  factory FlyyWalletCompleteData.fromJson(Map<String, dynamic> json) {
    return FlyyWalletCompleteData(
      balance: json['balance'],
      totalEarned: json['total_earned'],
      totalRedeemed: json['total_redeemed'],
      rewardType: json['reward_type'],
      rewardIcon: json['reward_icon'],
      walletMessage: json['wallet_message'],
      flyyTransactions:
          json.containsKey('transactions') && json['transactions'] != null
              ? List<FlyyTransactions>.from(json['transactions']
                  .map((data) => FlyyTransactions.fromJson(data)))
              : null,
      isRedeemable: json['is_redeemable'],
      minRedeemAmount: json['min_redeem_amount'],
      transactionsCount: json['transactions_count'],
      flyyTransferRequest: json.containsKey('transfer_request') &&
              json['transfer_request'] != null
          ? FlyyTransferRequest.fromJson(json['transfer_request'])
          : null,
      flyyAccountDetails:
          json.containsKey('account_details') && json['account_details'] != null
              ? FlyyAccountDetails.fromJson(json['account_details'])
              : null,
    );
  }
}
